# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/00_create_vars.ipynb.

# %% auto 0
__all__ = ['verifica_tamanho', 'ajuste_tempo', 'mode', 'create_vars_in_time']

# %% ../nbs/00_create_vars.ipynb 3
from fastcore.test import *
from fastcore.utils import *
import pandas as pd

# %% ../nbs/00_create_vars.ipynb 5
def verifica_tamanho(valores, n):
    return all(len(str(valor)) == n for valor in valores)

# %% ../nbs/00_create_vars.ipynb 7
def ajuste_tempo(df_, trns_time:str, ref_time:str):    

    if verifica_tamanho(df_[trns_time], n=6):
            # Cria datas com o formato YYYYMMDD para safra 
            df_['Safra_'] = df_[trns_time].apply(lambda x: str(x)+'01').apply(pd.to_datetime)
    elif verifica_tamanho(df_[trns_time], n=8):
            df_['Safra_'] = pd.to_datetime(df_[trns_time], format='%Y%m%d')
    else:
        print('Data da Safra no formato inválido!')

    if verifica_tamanho(df_[ref_time], n=6):
        # Cria datas com o formato YYYYMMDD para data de ref
        df_['ref_time_var_'] = df_[ref_time].apply(lambda x: str(x)+'01').apply(pd.to_datetime) 
    elif verifica_tamanho(df_[ref_time], n=8):
        df_['ref_time_var_'] = pd.to_datetime(df_[ref_time], format='%Y%m%d')
    else:
        print('Data de ref no formato inválido!')   


    return df_

# %% ../nbs/00_create_vars.ipynb 10
def mode(x):
    return pd.Series.mode(x).values[0]

# %% ../nbs/00_create_vars.ipynb 13
def create_vars_in_time(df_,id_cols,trns_time:str,ref_time:str,value_vars:list,window:list,operations:list):
    
    df = df_.copy()
    df_spine =  df[id_cols].drop_duplicates()
    df = ajuste_tempo(df, trns_time, ref_time)
    trns_time_var = "Safra_"
    ref_time_var = 'ref_time_var_'

    for var in value_vars:
        for size in window:
            time_cond = (df[trns_time_var] < df[ref_time_var]) & (df[trns_time_var] >= df[ref_time_var] + pd.DateOffset(months=size))
            df_grouped = df[time_cond].groupby(id_cols).agg({var:operations})
            df_grouped.columns = ['_'.join(col).strip()+'_'+str(abs(size))+'M' for col in df_grouped.columns.values]
            df_grouped.reset_index(inplace=True)
            df_spine = df_spine.merge(df_grouped,on=id_cols,how='left')
           
    return df_spine
